(require :climxm)
(use-package :excl)

(in-package :clim-user)

(define-application-frame test ()
  ()
  (:panes   
   (display :application
	    :text-cursor nil
            :width :compute :height :compute))
  (:layouts    
   (default display)))

(define-application-frame test2 ()
  ()
  (:panes   
   (display :application
	    :text-cursor nil
            :width :compute :height :compute))
  (:layouts    
   (default display)))

;(define-test-command (com-quit :menu t) ()
;  (frame-exit *application-frame*))

(defvar *test-frame* nil)

(defun test ()
  (let ((frame (or *test-frame*
		   (setf *test-frame*
		     (make-application-frame 'test)))))
    (mp:process-run-function "CLIMage Viewer" #'run-frame-top-level frame)))

(defvar *test-frame2* nil)

(defun test2 ()
  (let ((frame2 (or *test-frame2*
		   (setf *test-frame2*
		     (make-application-frame 'test2)))))
    (mp:process-run-function "CLIMage Viewer" #'run-frame-top-level frame2)))

(defun draw-image (arr pane)
  (let* ((width  (array-dimension arr 0))
	 (width  (array-dimension arr 0)))
   (do* ((j 1 (+ j 1)))
      	  ((= j (- (array-dimension arr 1) 1)))
	      (do* ((i 1 (+ i 1)))
      	      	  ((= i (- width 1)))
		(draw-point* pane j i :ink (make-gray-color (/ (aref arr i j) 255)) )))))
(compile 'draw-image)

;;; evaluate the following to create and display the frame:
(defun image-to-pixmap (arr)
  (let* ((frame       (test))
 	 ;;; after calling (test) and the frame has appeared evaluate...
  	 (*test-pane* (get-frame-pane *test-frame* 'display))
	 (baz (draw-image img *test-pane*)))
     (copy-to-pixmap  *test-pane* 0 0 (array-dimension img 1) (array-dimension img 0))))

(defun showpixmap (pixmap)
   (let* ((frame2       (test2))
 	 ;;; after calling (test) and the frame has appeared evaluate...
  	 (*test-pane2* (get-frame-pane *test-frame2* 'display))
	 (border      (draw-rectangle* *test-pane2* 0 0 (pixmap-width pixmap) (pixmap-height pixmap) 
				       :filled nil :line-thickness 1)))
   (copy-from-pixmap pixmap  0 0 (pixmap-width pixmap) (pixmap-height pixmap) *test-pane2* 0 0)))



;Always the first step: load the VIGRA CL Lib
(load "vigracl.cl")

(print "loading blox-image")
(time (setq img (vigracl.impex:loadimage  "blox.gif")))
(setq pixmap (image-to-pixmap img))
(showpixmap pixmap)