;Always the first step: load the VIGRA CL Lib
(load "vigracl.cl")

(in-package :vigracl)
;read the image
(print "loading rect-image")
(time (setq imgrect (loadimage "rect.gif")))

;do fast fourier transform
(print "performing fft on image")
(time (setq imgrectfft (fouriertransform imgrect 500 500)))

; Calculate the amplitude of the frequency spectrum
(defun square (x) (* x x))
(setq imgfft (array-map (array-combine (array-map (car imgrectfft) #'square) 
					(array-map (cdr imgrectfft) #'square)
					#'+ )
			 #'sqrt))

; Save:
       ;real part
(saveimage (car imgrectfft) "rect-fft-real.png")
       ;imaginary part
(saveimage (cdr imgrectfft) "rect-fft-imag.png")
       ;amplitude
(saveimage imgfft "rect-fft.png")
       ;amplitude (sqrt scaled)
(saveimage (array-map imgfft #'sqrt) "rect-fft-sqrt.png")
